#pragma once
#include "GLUtil.h"

class GLApp
{
public:
    GLApp();
    GLApp(HINSTANCE hInstance);
    virtual ~GLApp();

    UINT GetWidth();
    UINT GetHeight();

    // Main application loop
    int Run();

    // Framework methods
    virtual bool Init();
    virtual void Update(float dt) = 0;
    virtual void Render() = 0;
    virtual LRESULT MsgProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);

protected:
    HWND        m_hAppWnd;
    HINSTANCE   m_hAppInstance;
    HDC         m_hDevContext;
    HGLRC       m_hGLRenderContext;
    UINT        m_ClientWidth;
    UINT        m_ClientHeight;
    DWORD       m_WindowStyle;
    LPCTSTR     m_AppTitle;
    float       m_FPS;

protected:
    
    // Initialize window
    bool InitWindow();

    // Initialize OpenGL
    bool InitGL();

    // Calculates frames per second
    void CalculateFPS(float dt);

    // Shutdown OpenGL
    void Shutdown();
};
